/* Dialogs.c generated by valac 0.56.17, the Vala compiler
 * generated from Dialogs.vala, do not modify */

/* Dialogs.vala
 *
 * Copyright 2023 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <adwaita.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB,
	TERMINAL_CONFIRM_CLOSING_CONTEXT_WINDOW
} TerminalConfirmClosingContext;

#define TERMINAL_TYPE_CONFIRM_CLOSING_CONTEXT (terminal_confirm_closing_context_get_type ())
typedef enum  {
	TERMINAL_CONFIRM_ACTION_TYPE_NO_YES,
	TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK,
	TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE,
	TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE
} TerminalConfirmActionType;

#define TERMINAL_TYPE_CONFIRM_ACTION_TYPE (terminal_confirm_action_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block13Data Block13Data;
typedef struct _TerminalConfirmActionData TerminalConfirmActionData;
typedef struct _TerminalConfirmClosingData TerminalConfirmClosingData;

struct _Block13Data {
	int _ref_count_;
	gboolean response;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gpointer _async_data_;
};

struct _TerminalConfirmActionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar* title;
	gchar* body;
	TerminalConfirmActionType confirm_type;
	AdwResponseAppearance appearance1;
	AdwResponseAppearance appearance2;
	GtkWidget* extra_child;
	gboolean result;
	Block13Data* _data13_;
	gchar** labels;
	gint _tmp0_;
	gchar** _tmp1_;
	gint labels_length1;
	gint _labels_size_;
	gint _tmp2_;
	gchar** _tmp3_;
	AdwAlertDialog* d;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GtkWidget* _tmp10_;
	AdwAlertDialog* _tmp11_;
	AdwAlertDialog* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_;
	AdwAlertDialog* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	const gchar* _tmp21_;
	AdwAlertDialog* _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	const gchar* _tmp24_;
	AdwAlertDialog* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	const gchar* _tmp27_;
	AdwAlertDialog* _tmp28_;
	GtkApplication* _tmp29_;
	GApplication* _tmp30_;
	GtkWindow* _tmp31_;
	GtkWindow* _tmp32_;
	AdwAlertDialog* _tmp33_;
};

struct _TerminalConfirmClosingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	gchar** commands;
	gint commands_length1;
	TerminalConfirmClosingContext context;
	gboolean result;
	GtkWidget* child;
	gboolean _tmp0_;
	GtkListBox* list;
	gchar* _tmp1_;
	gchar** _tmp2_;
	GtkListBox* _tmp3_;
	gchar** command_collection;
	gint command_collection_length1;
	gint _command_collection_size_;
	gint command_it;
	const gchar* command;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	AdwActionRow* row;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	AdwActionRow* _tmp9_;
	GtkListBox* _tmp10_;
	AdwActionRow* _tmp11_;
	GtkListBox* _tmp12_;
	GtkWidget* _tmp13_;
	const gchar* _tmp14_;
	gchar* title;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* body;
	gchar* _tmp17_;
	gboolean response;
	const gchar* _tmp18_;
	GtkWidget* _tmp19_;
};

VALA_EXTERN GType terminal_confirm_closing_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType terminal_confirm_action_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar** terminal_confirm_action_type_get_labels (TerminalConfirmActionType self,
                                                 gint* result_length1);
VALA_EXTERN gchar** terminal_confirm_action_type_get_values (TerminalConfirmActionType self,
                                                 gint* result_length1);
static void terminal_confirm_action_data_free (gpointer _data);
VALA_EXTERN void terminal_confirm_action (const gchar* title,
                              const gchar* body,
                              TerminalConfirmActionType confirm_type,
                              AdwResponseAppearance appearance1,
                              AdwResponseAppearance appearance2,
                              GtkWidget* extra_child,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
VALA_EXTERN gboolean terminal_confirm_action_finish (GAsyncResult* _res_);
static gboolean terminal_confirm_action_co (TerminalConfirmActionData* _data_);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static gboolean _terminal_confirm_action_co_gsource_func (gpointer self);
static void __lambda30_ (Block13Data* _data13_,
                  const gchar* _response);
static void ___lambda30__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
static void terminal_confirm_closing_data_free (gpointer _data);
VALA_EXTERN void terminal_confirm_closing (gchar** commands,
                               gint commands_length1,
                               TerminalConfirmClosingContext context,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN gboolean terminal_confirm_closing_finish (GAsyncResult* _res_);
static gboolean terminal_confirm_closing_co (TerminalConfirmClosingData* _data_);
static void terminal_confirm_closing_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
terminal_confirm_closing_context_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB, "TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB", "tab"}, {TERMINAL_CONFIRM_CLOSING_CONTEXT_WINDOW, "TERMINAL_CONFIRM_CLOSING_CONTEXT_WINDOW", "window"}, {0, NULL, NULL}};
	GType terminal_confirm_closing_context_type_id;
	terminal_confirm_closing_context_type_id = g_enum_register_static ("TerminalConfirmClosingContext", values);
	return terminal_confirm_closing_context_type_id;
}

GType
terminal_confirm_closing_context_get_type (void)
{
	static volatile gsize terminal_confirm_closing_context_type_id__once = 0;
	if (g_once_init_enter (&terminal_confirm_closing_context_type_id__once)) {
		GType terminal_confirm_closing_context_type_id;
		terminal_confirm_closing_context_type_id = terminal_confirm_closing_context_get_type_once ();
		g_once_init_leave (&terminal_confirm_closing_context_type_id__once, terminal_confirm_closing_context_type_id);
	}
	return terminal_confirm_closing_context_type_id__once;
}

gchar**
terminal_confirm_action_type_get_labels (TerminalConfirmActionType self,
                                         gint* result_length1)
{
	gchar** result;
#line 34 "../src/utils/Dialogs.vala"
	switch (self) {
#line 34 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_NO_YES:
#line 262 "Dialogs.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_;
			gint _tmp3__length1;
#line 35 "../src/utils/Dialogs.vala"
			_tmp0_ = g_strdup (_ ("No"));
#line 35 "../src/utils/Dialogs.vala"
			_tmp1_ = g_strdup (_ ("Yes"));
#line 35 "../src/utils/Dialogs.vala"
			_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 35 "../src/utils/Dialogs.vala"
			_tmp2_[0] = _tmp0_;
#line 35 "../src/utils/Dialogs.vala"
			_tmp2_[1] = _tmp1_;
#line 35 "../src/utils/Dialogs.vala"
			_tmp3_ = _tmp2_;
#line 35 "../src/utils/Dialogs.vala"
			_tmp3__length1 = 2;
#line 35 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 35 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp3__length1;
#line 287 "Dialogs.c"
			}
#line 35 "../src/utils/Dialogs.vala"
			result = _tmp3_;
#line 35 "../src/utils/Dialogs.vala"
			return result;
#line 293 "Dialogs.c"
		}
#line 34 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK:
#line 297 "Dialogs.c"
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
#line 36 "../src/utils/Dialogs.vala"
			_tmp4_ = g_strdup (_ ("Cancel"));
#line 36 "../src/utils/Dialogs.vala"
			_tmp5_ = g_strdup (_ ("OK"));
#line 36 "../src/utils/Dialogs.vala"
			_tmp6_ = g_new0 (gchar*, 2 + 1);
#line 36 "../src/utils/Dialogs.vala"
			_tmp6_[0] = _tmp4_;
#line 36 "../src/utils/Dialogs.vala"
			_tmp6_[1] = _tmp5_;
#line 36 "../src/utils/Dialogs.vala"
			_tmp7_ = _tmp6_;
#line 36 "../src/utils/Dialogs.vala"
			_tmp7__length1 = 2;
#line 36 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 36 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp7__length1;
#line 322 "Dialogs.c"
			}
#line 36 "../src/utils/Dialogs.vala"
			result = _tmp7_;
#line 36 "../src/utils/Dialogs.vala"
			return result;
#line 328 "Dialogs.c"
		}
#line 34 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE:
#line 332 "Dialogs.c"
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
#line 37 "../src/utils/Dialogs.vala"
			_tmp8_ = g_strdup (_ ("Keep"));
#line 37 "../src/utils/Dialogs.vala"
			_tmp9_ = g_strdup (_ ("Replace"));
#line 37 "../src/utils/Dialogs.vala"
			_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 37 "../src/utils/Dialogs.vala"
			_tmp10_[0] = _tmp8_;
#line 37 "../src/utils/Dialogs.vala"
			_tmp10_[1] = _tmp9_;
#line 37 "../src/utils/Dialogs.vala"
			_tmp11_ = _tmp10_;
#line 37 "../src/utils/Dialogs.vala"
			_tmp11__length1 = 2;
#line 37 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 37 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp11__length1;
#line 357 "Dialogs.c"
			}
#line 37 "../src/utils/Dialogs.vala"
			result = _tmp11_;
#line 37 "../src/utils/Dialogs.vala"
			return result;
#line 363 "Dialogs.c"
		}
#line 34 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE:
#line 367 "Dialogs.c"
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
#line 38 "../src/utils/Dialogs.vala"
			_tmp12_ = g_strdup (_ ("Cancel"));
#line 38 "../src/utils/Dialogs.vala"
			_tmp13_ = g_strdup (_ ("Close"));
#line 38 "../src/utils/Dialogs.vala"
			_tmp14_ = g_new0 (gchar*, 2 + 1);
#line 38 "../src/utils/Dialogs.vala"
			_tmp14_[0] = _tmp12_;
#line 38 "../src/utils/Dialogs.vala"
			_tmp14_[1] = _tmp13_;
#line 38 "../src/utils/Dialogs.vala"
			_tmp15_ = _tmp14_;
#line 38 "../src/utils/Dialogs.vala"
			_tmp15__length1 = 2;
#line 38 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 38 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp15__length1;
#line 392 "Dialogs.c"
			}
#line 38 "../src/utils/Dialogs.vala"
			result = _tmp15_;
#line 38 "../src/utils/Dialogs.vala"
			return result;
#line 398 "Dialogs.c"
		}
		default:
#line 34 "../src/utils/Dialogs.vala"
		break;
#line 403 "Dialogs.c"
	}
#line 40 "../src/utils/Dialogs.vala"
	g_error ("Dialogs.vala:40: Invalid ConfirmActionType %d", (gint) self);
#line 407 "Dialogs.c"
}

gchar**
terminal_confirm_action_type_get_values (TerminalConfirmActionType self,
                                         gint* result_length1)
{
	gchar** result;
#line 44 "../src/utils/Dialogs.vala"
	switch (self) {
#line 44 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_NO_YES:
#line 419 "Dialogs.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_;
			gint _tmp3__length1;
#line 45 "../src/utils/Dialogs.vala"
			_tmp0_ = g_strdup ("no");
#line 45 "../src/utils/Dialogs.vala"
			_tmp1_ = g_strdup ("yes");
#line 45 "../src/utils/Dialogs.vala"
			_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 45 "../src/utils/Dialogs.vala"
			_tmp2_[0] = _tmp0_;
#line 45 "../src/utils/Dialogs.vala"
			_tmp2_[1] = _tmp1_;
#line 45 "../src/utils/Dialogs.vala"
			_tmp3_ = _tmp2_;
#line 45 "../src/utils/Dialogs.vala"
			_tmp3__length1 = 2;
#line 45 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 45 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp3__length1;
#line 444 "Dialogs.c"
			}
#line 45 "../src/utils/Dialogs.vala"
			result = _tmp3_;
#line 45 "../src/utils/Dialogs.vala"
			return result;
#line 450 "Dialogs.c"
		}
#line 44 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK:
#line 454 "Dialogs.c"
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
#line 46 "../src/utils/Dialogs.vala"
			_tmp4_ = g_strdup ("cancel");
#line 46 "../src/utils/Dialogs.vala"
			_tmp5_ = g_strdup ("ok");
#line 46 "../src/utils/Dialogs.vala"
			_tmp6_ = g_new0 (gchar*, 2 + 1);
#line 46 "../src/utils/Dialogs.vala"
			_tmp6_[0] = _tmp4_;
#line 46 "../src/utils/Dialogs.vala"
			_tmp6_[1] = _tmp5_;
#line 46 "../src/utils/Dialogs.vala"
			_tmp7_ = _tmp6_;
#line 46 "../src/utils/Dialogs.vala"
			_tmp7__length1 = 2;
#line 46 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 46 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp7__length1;
#line 479 "Dialogs.c"
			}
#line 46 "../src/utils/Dialogs.vala"
			result = _tmp7_;
#line 46 "../src/utils/Dialogs.vala"
			return result;
#line 485 "Dialogs.c"
		}
#line 44 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE:
#line 489 "Dialogs.c"
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
#line 47 "../src/utils/Dialogs.vala"
			_tmp8_ = g_strdup ("keep");
#line 47 "../src/utils/Dialogs.vala"
			_tmp9_ = g_strdup ("replace");
#line 47 "../src/utils/Dialogs.vala"
			_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 47 "../src/utils/Dialogs.vala"
			_tmp10_[0] = _tmp8_;
#line 47 "../src/utils/Dialogs.vala"
			_tmp10_[1] = _tmp9_;
#line 47 "../src/utils/Dialogs.vala"
			_tmp11_ = _tmp10_;
#line 47 "../src/utils/Dialogs.vala"
			_tmp11__length1 = 2;
#line 47 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 47 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp11__length1;
#line 514 "Dialogs.c"
			}
#line 47 "../src/utils/Dialogs.vala"
			result = _tmp11_;
#line 47 "../src/utils/Dialogs.vala"
			return result;
#line 520 "Dialogs.c"
		}
#line 44 "../src/utils/Dialogs.vala"
		case TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE:
#line 524 "Dialogs.c"
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
#line 48 "../src/utils/Dialogs.vala"
			_tmp12_ = g_strdup ("cancel");
#line 48 "../src/utils/Dialogs.vala"
			_tmp13_ = g_strdup ("close");
#line 48 "../src/utils/Dialogs.vala"
			_tmp14_ = g_new0 (gchar*, 2 + 1);
#line 48 "../src/utils/Dialogs.vala"
			_tmp14_[0] = _tmp12_;
#line 48 "../src/utils/Dialogs.vala"
			_tmp14_[1] = _tmp13_;
#line 48 "../src/utils/Dialogs.vala"
			_tmp15_ = _tmp14_;
#line 48 "../src/utils/Dialogs.vala"
			_tmp15__length1 = 2;
#line 48 "../src/utils/Dialogs.vala"
			if (result_length1) {
#line 48 "../src/utils/Dialogs.vala"
				*result_length1 = _tmp15__length1;
#line 549 "Dialogs.c"
			}
#line 48 "../src/utils/Dialogs.vala"
			result = _tmp15_;
#line 48 "../src/utils/Dialogs.vala"
			return result;
#line 555 "Dialogs.c"
		}
		default:
#line 44 "../src/utils/Dialogs.vala"
		break;
#line 560 "Dialogs.c"
	}
#line 50 "../src/utils/Dialogs.vala"
	g_error ("Dialogs.vala:50: Invalid ConfirmActionType %d", (gint) self);
#line 564 "Dialogs.c"
}

static GType
terminal_confirm_action_type_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_CONFIRM_ACTION_TYPE_NO_YES, "TERMINAL_CONFIRM_ACTION_TYPE_NO_YES", "no-yes"}, {TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK, "TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_OK", "cancel-ok"}, {TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE, "TERMINAL_CONFIRM_ACTION_TYPE_KEEP_REPLACE", "keep-replace"}, {TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE, "TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE", "cancel-close"}, {0, NULL, NULL}};
	GType terminal_confirm_action_type_type_id;
	terminal_confirm_action_type_type_id = g_enum_register_static ("TerminalConfirmActionType", values);
	return terminal_confirm_action_type_type_id;
}

GType
terminal_confirm_action_type_get_type (void)
{
	static volatile gsize terminal_confirm_action_type_type_id__once = 0;
	if (g_once_init_enter (&terminal_confirm_action_type_type_id__once)) {
		GType terminal_confirm_action_type_type_id;
		terminal_confirm_action_type_type_id = terminal_confirm_action_type_get_type_once ();
		g_once_init_leave (&terminal_confirm_action_type_type_id__once, terminal_confirm_action_type_type_id);
	}
	return terminal_confirm_action_type_type_id__once;
}

static void
terminal_confirm_action_data_free (gpointer _data)
{
	TerminalConfirmActionData* _data_;
	_data_ = _data;
	_g_free0 (_data_->title);
	_g_free0 (_data_->body);
	_g_object_unref0 (_data_->extra_child);
	g_slice_free (TerminalConfirmActionData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
terminal_confirm_action (const gchar* title,
                         const gchar* body,
                         TerminalConfirmActionType confirm_type,
                         AdwResponseAppearance appearance1,
                         AdwResponseAppearance appearance2,
                         GtkWidget* extra_child,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	TerminalConfirmActionData* _data_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkWidget* _tmp2_;
	g_return_if_fail (title != NULL);
	g_return_if_fail (body != NULL);
	_data_ = g_slice_new0 (TerminalConfirmActionData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_confirm_action_data_free);
	_tmp0_ = g_strdup (title);
	_g_free0 (_data_->title);
	_data_->title = _tmp0_;
	_tmp1_ = g_strdup (body);
	_g_free0 (_data_->body);
	_data_->body = _tmp1_;
	_data_->confirm_type = confirm_type;
	_data_->appearance1 = appearance1;
	_data_->appearance2 = appearance2;
	_tmp2_ = _g_object_ref0 (extra_child);
	_g_object_unref0 (_data_->extra_child);
	_data_->extra_child = _tmp2_;
	terminal_confirm_action_co (_data_);
}

gboolean
terminal_confirm_action_finish (GAsyncResult* _res_)
{
	gboolean result;
	TerminalConfirmActionData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 54 "../src/utils/Dialogs.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 54 "../src/utils/Dialogs.vala"
	return _data13_;
#line 656 "Dialogs.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 54 "../src/utils/Dialogs.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 54 "../src/utils/Dialogs.vala"
		_data13_->values = (_vala_array_free (_data13_->values, _data13_->values_length1, (GDestroyNotify) g_free), NULL);
#line 54 "../src/utils/Dialogs.vala"
		(_data13_->callback_target_destroy_notify == NULL) ? NULL : (_data13_->callback_target_destroy_notify (_data13_->callback_target), NULL);
#line 54 "../src/utils/Dialogs.vala"
		_data13_->callback = NULL;
#line 54 "../src/utils/Dialogs.vala"
		_data13_->callback_target = NULL;
#line 54 "../src/utils/Dialogs.vala"
		_data13_->callback_target_destroy_notify = NULL;
#line 54 "../src/utils/Dialogs.vala"
		g_slice_free (Block13Data, _data13_);
#line 678 "Dialogs.c"
	}
}

static gboolean
_terminal_confirm_action_co_gsource_func (gpointer self)
{
	gboolean result;
	result = terminal_confirm_action_co (self);
#line 63 "../src/utils/Dialogs.vala"
	return result;
#line 689 "Dialogs.c"
}

static void
__lambda30_ (Block13Data* _data13_,
             const gchar* _response)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	GSourceFunc _tmp2_;
	gpointer _tmp2__target;
#line 83 "../src/utils/Dialogs.vala"
	g_return_if_fail (_response != NULL);
#line 84 "../src/utils/Dialogs.vala"
	_tmp0_ = _data13_->values;
#line 84 "../src/utils/Dialogs.vala"
	_tmp0__length1 = _data13_->values_length1;
#line 84 "../src/utils/Dialogs.vala"
	_tmp1_ = _tmp0_[1];
#line 84 "../src/utils/Dialogs.vala"
	_data13_->response = g_strcmp0 (_response, _tmp1_) == 0;
#line 85 "../src/utils/Dialogs.vala"
	_tmp2_ = _data13_->callback;
#line 85 "../src/utils/Dialogs.vala"
	_tmp2__target = _data13_->callback_target;
#line 85 "../src/utils/Dialogs.vala"
	_tmp2_ (_tmp2__target);
#line 717 "Dialogs.c"
}

static void
___lambda30__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 83 "../src/utils/Dialogs.vala"
	__lambda30_ (self, response);
#line 727 "Dialogs.c"
}

static gboolean
terminal_confirm_action_co (TerminalConfirmActionData* _data_)
{
#line 54 "../src/utils/Dialogs.vala"
	switch (_data_->_state_) {
#line 54 "../src/utils/Dialogs.vala"
		case 0:
#line 737 "Dialogs.c"
		goto _state_0;
#line 54 "../src/utils/Dialogs.vala"
		case 1:
#line 741 "Dialogs.c"
		goto _state_1;
		default:
#line 54 "../src/utils/Dialogs.vala"
		g_assert_not_reached ();
#line 746 "Dialogs.c"
	}
	_state_0:
#line 54 "../src/utils/Dialogs.vala"
	_data_->_data13_ = g_slice_new0 (Block13Data);
#line 54 "../src/utils/Dialogs.vala"
	_data_->_data13_->_ref_count_ = 1;
#line 54 "../src/utils/Dialogs.vala"
	_data_->_data13_->_async_data_ = _data_;
#line 62 "../src/utils/Dialogs.vala"
	_data_->_data13_->response = FALSE;
#line 63 "../src/utils/Dialogs.vala"
	_data_->_data13_->callback = _terminal_confirm_action_co_gsource_func;
#line 63 "../src/utils/Dialogs.vala"
	_data_->_data13_->callback_target = _data_;
#line 63 "../src/utils/Dialogs.vala"
	_data_->_data13_->callback_target_destroy_notify = NULL;
#line 65 "../src/utils/Dialogs.vala"
	_data_->_tmp0_ = 0;
#line 65 "../src/utils/Dialogs.vala"
	_data_->_tmp1_ = terminal_confirm_action_type_get_labels (_data_->confirm_type, &_data_->_tmp0_);
#line 65 "../src/utils/Dialogs.vala"
	_data_->labels = _data_->_tmp1_;
#line 65 "../src/utils/Dialogs.vala"
	_data_->labels_length1 = _data_->_tmp0_;
#line 65 "../src/utils/Dialogs.vala"
	_data_->_labels_size_ = _data_->labels_length1;
#line 66 "../src/utils/Dialogs.vala"
	_data_->_tmp2_ = 0;
#line 66 "../src/utils/Dialogs.vala"
	_data_->_tmp3_ = terminal_confirm_action_type_get_values (_data_->confirm_type, &_data_->_tmp2_);
#line 66 "../src/utils/Dialogs.vala"
	_data_->_data13_->values = _data_->_tmp3_;
#line 66 "../src/utils/Dialogs.vala"
	_data_->_data13_->values_length1 = _data_->_tmp2_;
#line 66 "../src/utils/Dialogs.vala"
	_data_->_data13_->_values_size_ = _data_->_data13_->values_length1;
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp4_ = _data_->_data13_->values;
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp4__length1 = _data_->_data13_->values_length1;
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp5_ = _data_->_tmp4_[1];
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp6_ = g_strdup (_data_->_tmp5_);
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp7_ = _data_->_data13_->values;
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp7__length1 = _data_->_data13_->values_length1;
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp8_ = _data_->_tmp7_[0];
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp9_ = g_strdup (_data_->_tmp8_);
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->extra_child);
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp11_ = NULL;
#line 68 "../src/utils/Dialogs.vala"
	_data_->_tmp11_ = (AdwAlertDialog*) adw_alert_dialog_new (_data_->title, _data_->body);
#line 68 "../src/utils/Dialogs.vala"
	adw_alert_dialog_set_default_response (_data_->_tmp11_, _data_->_tmp6_);
#line 68 "../src/utils/Dialogs.vala"
	_g_free0 (_data_->_tmp6_);
#line 68 "../src/utils/Dialogs.vala"
	adw_alert_dialog_set_close_response (_data_->_tmp11_, _data_->_tmp9_);
#line 68 "../src/utils/Dialogs.vala"
	_g_free0 (_data_->_tmp9_);
#line 68 "../src/utils/Dialogs.vala"
	adw_alert_dialog_set_extra_child (_data_->_tmp11_, _data_->_tmp10_);
#line 68 "../src/utils/Dialogs.vala"
	_g_object_unref0 (_data_->_tmp10_);
#line 68 "../src/utils/Dialogs.vala"
	g_object_ref_sink (_data_->_tmp11_);
#line 68 "../src/utils/Dialogs.vala"
	_data_->d = _data_->_tmp11_;
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp12_ = _data_->d;
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp13_ = _data_->_data13_->values;
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp13__length1 = _data_->_data13_->values_length1;
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp14_ = _data_->_tmp13_[0];
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp15_ = _data_->labels;
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp15__length1 = _data_->labels_length1;
#line 77 "../src/utils/Dialogs.vala"
	_data_->_tmp16_ = _data_->_tmp15_[0];
#line 77 "../src/utils/Dialogs.vala"
	adw_alert_dialog_add_response (_data_->_tmp12_, _data_->_tmp14_, _data_->_tmp16_);
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp17_ = _data_->d;
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp18_ = _data_->_data13_->values;
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp18__length1 = _data_->_data13_->values_length1;
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp19_ = _data_->_tmp18_[1];
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp20_ = _data_->labels;
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp20__length1 = _data_->labels_length1;
#line 78 "../src/utils/Dialogs.vala"
	_data_->_tmp21_ = _data_->_tmp20_[1];
#line 78 "../src/utils/Dialogs.vala"
	adw_alert_dialog_add_response (_data_->_tmp17_, _data_->_tmp19_, _data_->_tmp21_);
#line 80 "../src/utils/Dialogs.vala"
	_data_->_tmp22_ = _data_->d;
#line 80 "../src/utils/Dialogs.vala"
	_data_->_tmp23_ = _data_->_data13_->values;
#line 80 "../src/utils/Dialogs.vala"
	_data_->_tmp23__length1 = _data_->_data13_->values_length1;
#line 80 "../src/utils/Dialogs.vala"
	_data_->_tmp24_ = _data_->_tmp23_[0];
#line 80 "../src/utils/Dialogs.vala"
	adw_alert_dialog_set_response_appearance (_data_->_tmp22_, _data_->_tmp24_, _data_->appearance1);
#line 81 "../src/utils/Dialogs.vala"
	_data_->_tmp25_ = _data_->d;
#line 81 "../src/utils/Dialogs.vala"
	_data_->_tmp26_ = _data_->_data13_->values;
#line 81 "../src/utils/Dialogs.vala"
	_data_->_tmp26__length1 = _data_->_data13_->values_length1;
#line 81 "../src/utils/Dialogs.vala"
	_data_->_tmp27_ = _data_->_tmp26_[1];
#line 81 "../src/utils/Dialogs.vala"
	adw_alert_dialog_set_response_appearance (_data_->_tmp25_, _data_->_tmp27_, _data_->appearance2);
#line 83 "../src/utils/Dialogs.vala"
	_data_->_tmp28_ = _data_->d;
#line 83 "../src/utils/Dialogs.vala"
	g_signal_connect_data (_data_->_tmp28_, "response", (GCallback) ___lambda30__adw_alert_dialog_response, block13_data_ref (_data_->_data13_), (GClosureNotify) block13_data_unref, 0);
#line 88 "../src/utils/Dialogs.vala"
	_data_->_tmp30_ = g_application_get_default ();
#line 88 "../src/utils/Dialogs.vala"
	_data_->_tmp29_ = G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp30_, gtk_application_get_type ()) ? ((GtkApplication*) _data_->_tmp30_) : NULL;
#line 88 "../src/utils/Dialogs.vala"
	_data_->_tmp31_ = NULL;
#line 88 "../src/utils/Dialogs.vala"
	if (_data_->_tmp29_ != NULL) {
#line 88 "../src/utils/Dialogs.vala"
		_data_->_tmp32_ = gtk_application_get_active_window (_data_->_tmp29_);
#line 88 "../src/utils/Dialogs.vala"
		_data_->_tmp31_ = _data_->_tmp32_;
#line 889 "Dialogs.c"
	}
#line 88 "../src/utils/Dialogs.vala"
	_data_->_tmp33_ = _data_->d;
#line 88 "../src/utils/Dialogs.vala"
	adw_dialog_present ((AdwDialog*) _data_->_tmp33_, (GtkWidget*) _data_->_tmp31_);
#line 90 "../src/utils/Dialogs.vala"
	_data_->_state_ = 1;
#line 90 "../src/utils/Dialogs.vala"
	return FALSE;
#line 899 "Dialogs.c"
	_state_1:
	;
#line 92 "../src/utils/Dialogs.vala"
	_data_->result = _data_->_data13_->response;
#line 92 "../src/utils/Dialogs.vala"
	_g_object_unref0 (_data_->d);
#line 92 "../src/utils/Dialogs.vala"
	_data_->labels = (_vala_array_free (_data_->labels, _data_->labels_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/utils/Dialogs.vala"
	block13_data_unref (_data_->_data13_);
#line 92 "../src/utils/Dialogs.vala"
	_data_->_data13_ = NULL;
#line 92 "../src/utils/Dialogs.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 92 "../src/utils/Dialogs.vala"
	if (_data_->_state_ != 0) {
#line 92 "../src/utils/Dialogs.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 92 "../src/utils/Dialogs.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 920 "Dialogs.c"
		}
	}
#line 92 "../src/utils/Dialogs.vala"
	g_object_unref (_data_->_async_result);
#line 92 "../src/utils/Dialogs.vala"
	return FALSE;
#line 927 "Dialogs.c"
}

static void
terminal_confirm_closing_data_free (gpointer _data)
{
	TerminalConfirmClosingData* _data_;
	_data_ = _data;
	g_slice_free (TerminalConfirmClosingData, _data_);
}

void
terminal_confirm_closing (gchar** commands,
                          gint commands_length1,
                          TerminalConfirmClosingContext context,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	TerminalConfirmClosingData* _data_;
	_data_ = g_slice_new0 (TerminalConfirmClosingData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, terminal_confirm_closing_data_free);
	_data_->commands = commands;
	_data_->commands_length1 = commands_length1;
	_data_->context = context;
	terminal_confirm_closing_co (_data_);
}

gboolean
terminal_confirm_closing_finish (GAsyncResult* _res_)
{
	gboolean result;
	TerminalConfirmClosingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
terminal_confirm_closing_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	TerminalConfirmClosingData* _data_;
#line 126 "../src/utils/Dialogs.vala"
	_data_ = _user_data_;
#line 126 "../src/utils/Dialogs.vala"
	_data_->_source_object_ = source_object;
#line 126 "../src/utils/Dialogs.vala"
	_data_->_res_ = _res_;
#line 126 "../src/utils/Dialogs.vala"
	terminal_confirm_closing_co (_data_);
#line 979 "Dialogs.c"
}

static gboolean
terminal_confirm_closing_co (TerminalConfirmClosingData* _data_)
{
#line 95 "../src/utils/Dialogs.vala"
	switch (_data_->_state_) {
#line 95 "../src/utils/Dialogs.vala"
		case 0:
#line 989 "Dialogs.c"
		goto _state_0;
#line 95 "../src/utils/Dialogs.vala"
		case 1:
#line 993 "Dialogs.c"
		goto _state_1;
		default:
#line 95 "../src/utils/Dialogs.vala"
		g_assert_not_reached ();
#line 998 "Dialogs.c"
	}
	_state_0:
#line 99 "../src/utils/Dialogs.vala"
	_data_->child = NULL;
#line 101 "../src/utils/Dialogs.vala"
	if (_data_->commands != NULL) {
#line 101 "../src/utils/Dialogs.vala"
		_data_->_tmp0_ = _data_->commands_length1 > 0;
#line 1007 "Dialogs.c"
	} else {
#line 101 "../src/utils/Dialogs.vala"
		_data_->_tmp0_ = FALSE;
#line 1011 "Dialogs.c"
	}
#line 101 "../src/utils/Dialogs.vala"
	if (_data_->_tmp0_) {
#line 102 "../src/utils/Dialogs.vala"
		_data_->_tmp1_ = g_strdup ("boxed-list");
#line 102 "../src/utils/Dialogs.vala"
		_data_->_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 102 "../src/utils/Dialogs.vala"
		_data_->_tmp2_[0] = _data_->_tmp1_;
#line 102 "../src/utils/Dialogs.vala"
		_data_->_tmp3_ = NULL;
#line 102 "../src/utils/Dialogs.vala"
		_data_->_tmp3_ = (GtkListBox*) gtk_list_box_new ();
#line 102 "../src/utils/Dialogs.vala"
		gtk_widget_set_css_classes ((GtkWidget*) _data_->_tmp3_, _data_->_tmp2_);
#line 102 "../src/utils/Dialogs.vala"
		_data_->_tmp2_ = (_vala_array_free (_data_->_tmp2_, 1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/utils/Dialogs.vala"
		gtk_list_box_set_selection_mode (_data_->_tmp3_, GTK_SELECTION_NONE);
#line 102 "../src/utils/Dialogs.vala"
		g_object_ref_sink (_data_->_tmp3_);
#line 102 "../src/utils/Dialogs.vala"
		_data_->list = _data_->_tmp3_;
#line 1035 "Dialogs.c"
		{
#line 107 "../src/utils/Dialogs.vala"
			_data_->command_collection_length1 = 0;
#line 107 "../src/utils/Dialogs.vala"
			_data_->_command_collection_size_ = 0;
#line 107 "../src/utils/Dialogs.vala"
			_data_->command_collection = _data_->commands;
#line 107 "../src/utils/Dialogs.vala"
			_data_->command_collection_length1 = _data_->commands_length1;
#line 107 "../src/utils/Dialogs.vala"
			for (_data_->command_it = 0; _data_->command_it < _data_->command_collection_length1; _data_->command_it = _data_->command_it + 1) {
#line 107 "../src/utils/Dialogs.vala"
				_data_->command = _data_->command_collection[_data_->command_it];
#line 1049 "Dialogs.c"
				{
#line 109 "../src/utils/Dialogs.vala"
					_data_->_tmp5_ = _data_->command;
#line 109 "../src/utils/Dialogs.vala"
					_data_->_tmp4_ = _data_->_tmp5_;
#line 109 "../src/utils/Dialogs.vala"
					if (_data_->_tmp4_ == NULL) {
#line 109 "../src/utils/Dialogs.vala"
						_data_->_tmp4_ = "";
#line 1059 "Dialogs.c"
					}
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp6_ = g_strdup (_data_->_tmp4_);
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp7_ = g_strdup ("monospace");
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp8_ = g_new0 (gchar*, 1 + 1);
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp8_[0] = _data_->_tmp7_;
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp9_ = NULL;
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp9_ = (AdwActionRow*) adw_action_row_new ();
#line 108 "../src/utils/Dialogs.vala"
					adw_preferences_row_set_title ((AdwPreferencesRow*) _data_->_tmp9_, _data_->_tmp6_);
#line 108 "../src/utils/Dialogs.vala"
					_g_free0 (_data_->_tmp6_);
#line 108 "../src/utils/Dialogs.vala"
					gtk_widget_set_css_classes ((GtkWidget*) _data_->_tmp9_, _data_->_tmp8_);
#line 108 "../src/utils/Dialogs.vala"
					_data_->_tmp8_ = (_vala_array_free (_data_->_tmp8_, 1, (GDestroyNotify) g_free), NULL);
#line 108 "../src/utils/Dialogs.vala"
					gtk_widget_set_can_focus ((GtkWidget*) _data_->_tmp9_, FALSE);
#line 108 "../src/utils/Dialogs.vala"
					g_object_ref_sink (_data_->_tmp9_);
#line 108 "../src/utils/Dialogs.vala"
					_data_->row = _data_->_tmp9_;
#line 113 "../src/utils/Dialogs.vala"
					_data_->_tmp10_ = _data_->list;
#line 113 "../src/utils/Dialogs.vala"
					_data_->_tmp11_ = _data_->row;
#line 113 "../src/utils/Dialogs.vala"
					gtk_list_box_append (_data_->_tmp10_, (GtkWidget*) _data_->_tmp11_);
#line 107 "../src/utils/Dialogs.vala"
					_g_object_unref0 (_data_->row);
#line 1095 "Dialogs.c"
				}
			}
		}
#line 115 "../src/utils/Dialogs.vala"
		_data_->_tmp12_ = _data_->list;
#line 115 "../src/utils/Dialogs.vala"
		_data_->_tmp13_ = _g_object_ref0 ((GtkWidget*) _data_->_tmp12_);
#line 115 "../src/utils/Dialogs.vala"
		_g_object_unref0 (_data_->child);
#line 115 "../src/utils/Dialogs.vala"
		_data_->child = _data_->_tmp13_;
#line 101 "../src/utils/Dialogs.vala"
		_g_object_unref0 (_data_->list);
#line 1109 "Dialogs.c"
	}
#line 118 "../src/utils/Dialogs.vala"
	if (_data_->context == TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB) {
#line 119 "../src/utils/Dialogs.vala"
		_data_->_tmp14_ = _ ("Close Tab?");
#line 1115 "Dialogs.c"
	} else {
#line 120 "../src/utils/Dialogs.vala"
		_data_->_tmp14_ = _ ("Close Window?");
#line 1119 "Dialogs.c"
	}
#line 118 "../src/utils/Dialogs.vala"
	_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
#line 118 "../src/utils/Dialogs.vala"
	_data_->title = _data_->_tmp15_;
#line 122 "../src/utils/Dialogs.vala"
	if (_data_->context == TERMINAL_CONFIRM_CLOSING_CONTEXT_TAB) {
#line 123 "../src/utils/Dialogs.vala"
		_data_->_tmp16_ = _ ("Some commands are still running. Closing this tab will kill them and m" \
"ay lead to unexpected outcomes.");
#line 1129 "Dialogs.c"
	} else {
#line 124 "../src/utils/Dialogs.vala"
		_data_->_tmp16_ = _ ("Some commands are still running. Closing this window will kill them an" \
"d may lead to unexpected outcomes.");
#line 1133 "Dialogs.c"
	}
#line 122 "../src/utils/Dialogs.vala"
	_data_->_tmp17_ = g_strdup (_data_->_tmp16_);
#line 122 "../src/utils/Dialogs.vala"
	_data_->body = _data_->_tmp17_;
#line 126 "../src/utils/Dialogs.vala"
	_data_->_tmp18_ = _data_->title;
#line 126 "../src/utils/Dialogs.vala"
	_data_->_tmp19_ = _data_->child;
#line 126 "../src/utils/Dialogs.vala"
	_data_->_state_ = 1;
#line 126 "../src/utils/Dialogs.vala"
	terminal_confirm_action (_data_->_tmp18_, _data_->body, TERMINAL_CONFIRM_ACTION_TYPE_CANCEL_CLOSE, ADW_RESPONSE_DEFAULT, ADW_RESPONSE_DESTRUCTIVE, _data_->_tmp19_, terminal_confirm_closing_ready, _data_);
#line 126 "../src/utils/Dialogs.vala"
	return FALSE;
#line 1149 "Dialogs.c"
	_state_1:
#line 126 "../src/utils/Dialogs.vala"
	_data_->response = terminal_confirm_action_finish (_data_->_res_);
#line 135 "../src/utils/Dialogs.vala"
	_data_->result = _data_->response;
#line 135 "../src/utils/Dialogs.vala"
	_g_free0 (_data_->body);
#line 135 "../src/utils/Dialogs.vala"
	_g_free0 (_data_->title);
#line 135 "../src/utils/Dialogs.vala"
	_g_object_unref0 (_data_->child);
#line 135 "../src/utils/Dialogs.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 135 "../src/utils/Dialogs.vala"
	if (_data_->_state_ != 0) {
#line 135 "../src/utils/Dialogs.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 135 "../src/utils/Dialogs.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1169 "Dialogs.c"
		}
	}
#line 135 "../src/utils/Dialogs.vala"
	g_object_unref (_data_->_async_result);
#line 135 "../src/utils/Dialogs.vala"
	return FALSE;
#line 1176 "Dialogs.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

